Bitrix API

DiscountCouponTable extends DataManager

Class DiscountCouponTable

Fields:

  • ID int mandatory
  • DISCOUNT_ID int mandatory
  • ACTIVE bool optional default 'Y'
  • COUPON string(32) mandatory
  • DATE_APPLY datetime optional
  • TYPE enum optional default 'O'
  • TIMESTAMP_X datetime optional
  • MODIFIED_BY int optional
  • DATE_CREATE datetime optional
  • CREATED_BY int optional
  • DESCRIPTION string optional
  • CREATED_BY_USER reference to [](\Bitrix\Main\UserTable)
  • MODIFIED_BY_USER reference to [](\Bitrix\Main\UserTable)
  • DISCOUNT reference to [](\Bitrix\Catalog\DiscountTable)

Table of Contents

Constants

EVENT_ON_ADD  = "OnAdd"
EVENT_ON_AFTER_ADD  = "OnAfterAdd"
EVENT_ON_AFTER_DELETE  = "OnAfterDelete"
EVENT_ON_AFTER_UPDATE  = "OnAfterUpdate"
EVENT_ON_BEFORE_ADD  = "OnBeforeAdd"
EVENT_ON_BEFORE_DELETE  = "OnBeforeDelete"
EVENT_ON_BEFORE_UPDATE  = "OnBeforeUpdate"
EVENT_ON_DELETE  = "OnDelete"
EVENT_ON_UPDATE  = "OnUpdate"
TYPE_NO_LIMIT  = 'N'
TYPE_ONE_ORDER  = 'O'
TYPE_ONE_ROW  = 'Y'

Methods

add()  : AddResult
Adds row to entity table
addMulti()  : AddResult
Adds several rows to entity table.
checkCoupon()  : bool|string
Validate coupon.
checkDiscountId()  : bool|string
Check discount id.
checkFields()  : mixed
Checks the data fields before saving to DB. Result stores in the $result object
cleanCache()  : void
Cleans the tablet cache after data modifications.
couponManager()  : EventResult
Return methods for coupons manager.
createCollection()  : EO_DiscountCoupon_Collection
createObject()  : EO_DiscountCoupon
cryptoEnabled()  : bool
Returns true if crypto is enabled for a field.
delete()  : DeleteResult
Deletes row in entity table by primary key
deleteByDiscount()  : void
Delete all coupons for discount.
enableCrypto()  : mixed
Sets a flag indicating crypto support for a field.
getById()  : EO_DiscountCoupon_Result
Returns selection by entity's primary key
getByPrimary()  : EO_DiscountCoupon_Result
Returns selection by entity's primary key and optional parameters for getList()
getCollectionClass()  : string|Collection
Returns class of Object collection for current entity.
getCollectionClassName()  : string
Returns class name (without namespace) of Object collection for current entity.
getCollectionParentClass()  : Collection|string
getConnectionName()  : string
Returns connection name for entity
getCount()  : int
Performs COUNT query on entity and returns the result.
getCouponTypes()  : array<string|int, mixed>
Returns coupon types list.
getData()  : array<string|int, mixed>|false
Return coupon description.
getEntity()  : EO_DiscountCoupon_Entity
Returns entity object
getEntityClass()  : Entity|string
getList()  : EO_DiscountCoupon_Result
Executes the query and returns selection by parameters of the query. This function is an alias to the Query object functions
getMap()  : array<string|int, mixed>
Returns entity map definition.
getObjectClass()  : string|EntityObject
Returns class of Object for current entity.
getObjectClassName()  : string
Returns class name (without namespace) of Object for current entity.
getObjectParentClass()  : EntityObject|string
getQueryClass()  : Query|string
getRow()  : array<string|int, mixed>|null
Returns one row (or null) by parameters for getList()
getRowById()  : array<string|int, mixed>|null
Returns one row (or null) by entity's primary key
getTableName()  : string
Returns DB table name for entity.
getTitle()  : string|null
getUfId()  : mixed
isCacheable()  : bool
You can disable cache for the tablet completely.
isExist()  : array<string|int, mixed>|false
Check existing coupon.
isUtm()  : mixed
isUts()  : mixed
onAdd()  : mixed
onAfterAdd()  : mixed
onAfterDelete()  : mixed
onAfterUpdate()  : mixed
onBeforeAdd()  : EventResult
Default onBeforeAdd handler. Absolutely necessary.
onBeforeDelete()  : mixed
onBeforeUpdate()  : EventResult
Default onBeforeUpdate handler. Absolutely necessary.
onDelete()  : mixed
onUpdate()  : mixed
postInitialize()  : null
query()  : EO_DiscountCoupon_Query
Creates and returns the Query object for the entity
saveApplied()  : array<string|int, mixed>|bool
Save apllied coupons.
setCurrentDeletingObject()  : void
setDefaultScope()  : Query
unsetEntity()  : mixed
update()  : UpdateResult
Updates row in entity table by primary key
updateMulti()  : UpdateResult
validateCoupon()  : array<string|int, mixed>
Returns validators for COUPON field.
validateDiscountId()  : array<string|int, mixed>
Returns validators for DISCOUNT_ID field.
wakeUpCollection()  : EO_DiscountCoupon_Collection
wakeUpObject()  : EO_DiscountCoupon

Constants

EVENT_ON_AFTER_ADD

public mixed EVENT_ON_AFTER_ADD = "OnAfterAdd"

EVENT_ON_AFTER_DELETE

public mixed EVENT_ON_AFTER_DELETE = "OnAfterDelete"

EVENT_ON_AFTER_UPDATE

public mixed EVENT_ON_AFTER_UPDATE = "OnAfterUpdate"

EVENT_ON_BEFORE_ADD

public mixed EVENT_ON_BEFORE_ADD = "OnBeforeAdd"

EVENT_ON_BEFORE_DELETE

public mixed EVENT_ON_BEFORE_DELETE = "OnBeforeDelete"

EVENT_ON_BEFORE_UPDATE

public mixed EVENT_ON_BEFORE_UPDATE = "OnBeforeUpdate"

EVENT_ON_DELETE

public mixed EVENT_ON_DELETE = "OnDelete"

EVENT_ON_UPDATE

public mixed EVENT_ON_UPDATE = "OnUpdate"

Methods

add()

Adds row to entity table

public static add(array<string|int, mixed> $data) : AddResult
Parameters
$data : array<string|int, mixed>

An array with fields like array( "fields" => array( "FIELD1" => "value1", "FIELD2" => "value2", ), "auth_context" => \Bitrix\Main\Authentication\Context object ) or just a plain array of fields.

This method uses the default strategy defined in the class.

Tags
throws
Exception
Return values
AddResult —

Contains ID of inserted row

addMulti()

Adds several rows to entity table.

public static addMulti(mixed $rows[, bool $ignoreEvents = false ]) : AddResult

This method uses the default strategy defined in the class.

Parameters
$rows : mixed
$ignoreEvents : bool = false
Tags
throws
ArgumentException
throws
SystemException
Return values
AddResult

checkCoupon()

Validate coupon.

public static checkCoupon(int $value, array<string|int, mixed>|int $primary, array<string|int, mixed> $row, Field $field) : bool|string
Parameters
$value : int

Coupon.

$primary : array<string|int, mixed>|int

Primary key.

$row : array<string|int, mixed>

Current data.

$field : Field

Field object.

Return values
bool|string

checkDiscountId()

Check discount id.

public static checkDiscountId(int $value, array<string|int, mixed>|int $primary, array<string|int, mixed> $row, Field $field) : bool|string
Parameters
$value : int

Discount id.

$primary : array<string|int, mixed>|int

Primary key.

$row : array<string|int, mixed>

Current data.

$field : Field

Field object.

Return values
bool|string

checkFields()

Checks the data fields before saving to DB. Result stores in the $result object

public static checkFields(Result $result, mixed $primary, array<string|int, mixed> $data) : mixed
Parameters
$result : Result
$primary : mixed
$data : array<string|int, mixed>
Tags
throws
ArgumentException
throws
SystemException

cleanCache()

Cleans the tablet cache after data modifications.

public static cleanCache() : void

createCollection()

public static createCollection() : EO_DiscountCoupon_Collection
Return values
EO_DiscountCoupon_Collection

createObject()

public static createObject([mixed $setDefaultValues = = 'true' ]) : EO_DiscountCoupon
Parameters
$setDefaultValues : mixed = = 'true'
Return values
EO_DiscountCoupon

cryptoEnabled()

Returns true if crypto is enabled for a field.

public static cryptoEnabled(string $field[, string $table = null ]) : bool
Parameters
$field : string
$table : string = null
Return values
bool

delete()

Deletes row in entity table by primary key

public static delete(mixed $primary) : DeleteResult
Parameters
$primary : mixed
Tags
throws
Exception
Return values
DeleteResult

deleteByDiscount()

Delete all coupons for discount.

public static deleteByDiscount(int $discount) : void
Parameters
$discount : int

Discount id.

enableCrypto()

Sets a flag indicating crypto support for a field.

public static enableCrypto(string $field[, string $table = null ][, bool $mode = true ]) : mixed
Parameters
$field : string
$table : string = null
$mode : bool = true

getById()

Returns selection by entity's primary key

public static getById(mixed $id) : EO_DiscountCoupon_Result
Parameters
$id : mixed

Primary key of the entity

Return values
EO_DiscountCoupon_Result

getByPrimary()

Returns selection by entity's primary key and optional parameters for getList()

public static getByPrimary(mixed $primary[, array<string|int, mixed> $parameters = = '[]' ]) : EO_DiscountCoupon_Result
Parameters
$primary : mixed

Primary key of the entity

$parameters : array<string|int, mixed> = = '[]'

Additional parameters for getList()

Return values
EO_DiscountCoupon_Result

getCollectionClass()

Returns class of Object collection for current entity.

public static getCollectionClass() : string|Collection
Return values
string|Collection

getCollectionClassName()

Returns class name (without namespace) of Object collection for current entity.

public final static getCollectionClassName() : string
Return values
string

getConnectionName()

Returns connection name for entity

public static getConnectionName() : string
Return values
string

getCount()

Performs COUNT query on entity and returns the result.

public static getCount([array<string|int, mixed>|ConditionTree $filter = array() ][, array<string|int, mixed> $cache = array() ]) : int
Parameters
$filter : array<string|int, mixed>|ConditionTree = array()
$cache : array<string|int, mixed> = array()

An array of cache options "ttl" => integer indicating cache TTL

Tags
throws
ObjectPropertyException
throws
SystemException
Return values
int

getCouponTypes()

Returns coupon types list.

public static getCouponTypes([bool $extendedMode = false ]) : array<string|int, mixed>
Parameters
$extendedMode : bool = false

Get type ids or ids with title.

Return values
array<string|int, mixed>

getData()

Return coupon description.

public static getData(string $coupon) : array<string|int, mixed>|false
Parameters
$coupon : string

Coupon for search.

Return values
array<string|int, mixed>|false

getEntity()

Returns entity object

public static getEntity() : EO_DiscountCoupon_Entity
Return values
EO_DiscountCoupon_Entity

getList()

Executes the query and returns selection by parameters of the query. This function is an alias to the Query object functions

public static getList([array<string|int, mixed> $parameters = = '[]' ]) : EO_DiscountCoupon_Result
Parameters
$parameters : array<string|int, mixed> = = '[]'

An array of query parameters, available keys are:
"select" => array of fields in the SELECT part of the query, aliases are possible in the form of "alias"=>"field";
"filter" => array of filters in the WHERE/HAVING part of the query in the form of "(condition)field"=>"value"; also could be an instance of Filter;
"group" => array of fields in the GROUP BY part of the query;
"order" => array of fields in the ORDER BY part of the query in the form of "field"=>"asc|desc";
"limit" => integer indicating maximum number of rows in the selection (like LIMIT n in MySql);
"offset" => integer indicating first row number in the selection (like LIMIT n, 100 in MySql);
"runtime" => array of entity fields created dynamically;
"cache => array of cache options:
"ttl" => integer indicating cache TTL;
"cache_joins" => boolean enabling to cache joins, false by default.

Return values
EO_DiscountCoupon_Result

getMap()

Returns entity map definition.

public static getMap() : array<string|int, mixed>
Return values
array<string|int, mixed>

getObjectClassName()

Returns class name (without namespace) of Object for current entity.

public final static getObjectClassName() : string
Return values
string

getRow()

Returns one row (or null) by parameters for getList()

public static getRow(array<string|int, mixed> $parameters) : array<string|int, mixed>|null
Parameters
$parameters : array<string|int, mixed>

Primary key of the entity

Tags
throws
ArgumentException
throws
ObjectPropertyException
throws
SystemException
Return values
array<string|int, mixed>|null

getRowById()

Returns one row (or null) by entity's primary key

public static getRowById(mixed $id[, array<string|int, mixed> $parameters = [] ]) : array<string|int, mixed>|null
Parameters
$id : mixed

Primary key of the entity

$parameters : array<string|int, mixed> = []

Additional parameters for getList()

Tags
throws
ArgumentException
throws
ObjectPropertyException
throws
SystemException
Return values
array<string|int, mixed>|null

getTableName()

Returns DB table name for entity.

public static getTableName() : string
Return values
string

getTitle()

public static getTitle() : string|null
Return values
string|null

isCacheable()

You can disable cache for the tablet completely.

public static isCacheable() : bool
Return values
bool

isExist()

Check existing coupon.

public static isExist(string $coupon) : array<string|int, mixed>|false
Parameters
$coupon : string

Coupon for checking.

Return values
array<string|int, mixed>|false

onBeforeAdd()

Default onBeforeAdd handler. Absolutely necessary.

public static onBeforeAdd(Event $event) : EventResult
Parameters
$event : Event

Current data for add.

Return values
EventResult

onBeforeUpdate()

Default onBeforeUpdate handler. Absolutely necessary.

public static onBeforeUpdate(Event $event) : EventResult
Parameters
$event : Event

Current data for update.

Return values
EventResult

postInitialize()

public static postInitialize(Entity $entity) : null
Parameters
$entity : Entity
Return values
null

query()

Creates and returns the Query object for the entity

public static query() : EO_DiscountCoupon_Query
Return values
EO_DiscountCoupon_Query

saveApplied()

Save apllied coupons.

public static saveApplied(array<string|int, mixed> $coupons, int $userId, DateTime $currentTime) : array<string|int, mixed>|bool
Parameters
$coupons : array<string|int, mixed>

Coupons list.

$userId : int

Order user id.

$currentTime : DateTime

Apply time.

Return values
array<string|int, mixed>|bool

unsetEntity()

public static unsetEntity(mixed $class) : mixed
Parameters
$class : mixed

update()

Updates row in entity table by primary key

public static update(mixed $primary, array<string|int, mixed> $data) : UpdateResult
Parameters
$primary : mixed
$data : array<string|int, mixed>

An array with fields like array( "fields" => array( "FIELD1" => "value1", "FIELD2" => "value2", ), "auth_context" => \Bitrix\Main\Authentication\Context object ) or just a plain array of fields.

Tags
throws
Exception
Return values
UpdateResult

updateMulti()

public static updateMulti(array<string|int, mixed> $primaries, array<string|int, mixed> $data[, bool $ignoreEvents = false ]) : UpdateResult
Parameters
$primaries : array<string|int, mixed>
$data : array<string|int, mixed>
$ignoreEvents : bool = false
Tags
throws
ArgumentException
throws
SystemException
Return values
UpdateResult

validateCoupon()

Returns validators for COUPON field.

public static validateCoupon() : array<string|int, mixed>
Return values
array<string|int, mixed>

validateDiscountId()

Returns validators for DISCOUNT_ID field.

public static validateDiscountId() : array<string|int, mixed>
Return values
array<string|int, mixed>

wakeUpCollection()

public static wakeUpCollection(mixed $rows) : EO_DiscountCoupon_Collection
Parameters
$rows : mixed
Return values
EO_DiscountCoupon_Collection

wakeUpObject()

public static wakeUpObject(mixed $row) : EO_DiscountCoupon
Parameters
$row : mixed
Return values
EO_DiscountCoupon

        
On this page

Search results